#include <avr/io.h>
#define F_CPU 16000000
#include <util/delay.h>

#include <stdio.h>
#include <stdlib.h>


int snake_len = 1;

int game_start = 0;

int x[8] = {7};
int y[8] = {4};

int direction = 0;

int foodx, auxx;
int foody, auxy;

int pa_array[8] = {PA0, PA1, PA2, PA3, PA4, PA5, PA6, PA7};
int pc_array[8] = {PC0, PC1, PC2, PC3, PC4, PC5, PC6, PC7};

/* matrice goala */
int matrix0[8][8] =
{
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0}
};




/* matricea initiala */
int matrix_game[8][8] =
{
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 1, 0, 0, 0}
};

/* litera Y */
int matrixover1[8][8] =
{
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 1, 0, 0, 0, 0, 1, 0},
	{0, 0, 1, 0, 0, 1, 0, 0},
	{0, 0, 0, 1, 1, 0, 0, 0},
	{0, 0, 0, 0, 1, 0, 0, 0},
	{0, 0, 0, 0, 1, 0, 0, 0},
	{0, 0, 0, 0, 1, 0, 0, 0},
	{0, 0, 0, 0, 1, 0, 0, 0}
};

/* litera O */
int matrixover2[8][8] =
{
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 1, 1, 1, 1, 0, 0},
	{0, 1, 0, 0, 0, 0, 1, 0},
	{0, 1, 0, 0, 0, 0, 1, 0},
	{0, 1, 0, 0, 0, 0, 1, 0},
	{0, 1, 0, 0, 0, 0, 1, 0},
	{0, 0, 1, 1, 1, 1, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0}
};

/* litera U */
int matrixover3[8][8] =
{
	{0, 1, 0, 0, 0, 1, 0, 0},
	{0, 1, 0, 0, 0, 1, 0, 0},
	{0, 1, 0, 0, 0, 1, 0, 0},
	{0, 1, 0, 0, 0, 1, 0, 0},
	{0, 1, 0, 0, 0, 1, 0, 0},
	{0, 1, 0, 0, 0, 1, 0, 0},
	{0, 1, 1, 1, 1, 1, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0}
};

/* litera L */
int matrixover4[8][8] =
{
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 1, 0, 0, 0, 0, 0, 0},
	{0, 1, 0, 0, 0, 0, 0, 0},
	{0, 1, 0, 0, 0, 0, 0, 0},
	{0, 1, 0, 0, 0, 0, 0, 0},
	{0, 1, 0, 0, 0, 0, 0, 0},
	{0, 1, 1, 1, 1, 1, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0}
};


/* litera S */
int matrixover5[8][8] =
{
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 1, 1, 1, 1, 0, 0, 0},
	{0, 1, 0, 0, 0, 0, 0, 0},
	{0, 1, 1, 1, 1, 0, 0, 0},
	{0, 0, 0, 0, 0, 1, 0, 0},
	{0, 0, 0, 0, 0, 1, 0, 0},
	{0, 1, 1, 1, 1, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0}
};

/* litera E */
int matrixover6[8][8] =
{
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 1, 1, 1, 1, 1, 1, 0},
	{0, 1, 0, 0, 0, 0, 0, 0},
	{0, 1, 1, 1, 1, 1, 1, 0},
	{0, 1, 0, 0, 0, 0, 0, 0},
	{0, 1, 0, 0, 0, 0, 0, 0},
	{0, 1, 1, 1, 1, 1, 1, 0},
	{0, 0, 0, 0, 0, 0, 0, 0}
};



/* Afisare matrice */
void draw_matrix(int matrix[8][8])
{
	int i, j;

	for (i = 0; i < 8; i++) {
		for (j = 0; j < 8; j++)
			if (matrix[j][i])
				PORTC |= (1 << pc_array[j]);
			else
				PORTC &= ~(1 << pc_array[j]);

		PORTA &= ~(1 << pa_array[i]);
		_delay_ms(0.4);
		PORTA |= (1 << pa_array[i]);
	}
}


/* Se genereaza hrana */
void gen_food()
{
	int a, b, i, ok;

	ok = 0;
	while (ok == 0) {
		ok = 1;
		/* generez doua numere random */
		a = rand() % 8;
		b = rand() % 8;

		/* verific daca punctul e deja ocupat */
		for (i = 0; i < snake_len; i++)
			if (x[i] == a && y[i] == b) {
					ok = 0;
					break;
			}

		if (ok)
			break;
	}

	foodx = a;
	foody = b;
}

/* update matrice */
int updatare_matrice()
{
	/* de a doua oara se updateaza matricea */
	if (game_start == 0) {
		game_start=1;
		return 0;
	}

	int i, xaux, yaux;
 
	xaux = x[snake_len - 1];
	yaux = y[snake_len - 1];
	if (direction == 0) {
		if (!x[0]) matrix_game[7][y[0]] = 1;
		else matrix_game[x[0] - 1][y[0]] = 1;
		
		for (i = 1; i < snake_len; i++)
			matrix_game[x[i - 1]][y[i - 1]] = matrix_game[x[i]][y[i]];

		matrix_game[x[snake_len - 1]][y[snake_len - 1]] = 0;

		for (i = snake_len - 1; i > 0; i--) {
			x[i] = x[i - 1];
			y[i] = y[i - 1];
		}

		if (!x[0]) x[0] = 7;
		else x[0] = x[0] - 1;

		if (x[0] == xaux && y[0] == yaux)
			return 1;
	}

	if (direction == 1) {
		if (x[0] == 7) matrix_game[0][y[0]] = 1;
		else matrix_game[x[0] + 1][y[0]] = 1;

		for (i = 1; i < snake_len; i++)
			matrix_game[x[i - 1]][y[i - 1]] = matrix_game[x[i]][y[i]];

		matrix_game[x[snake_len - 1]][y[snake_len - 1]] = 0;
		
		for (i = snake_len - 1; i > 0; i--) {
			x[i] = x[i - 1];
			y[i] = y[i - 1];
		}

		if (x[0] == 7) x[0] = 0;
		else x[0] = x[0] + 1;

		if (x[0] == xaux && y[0] == yaux)
			return 1;
	}

	if (direction == 2) {
		if (!y[0]) matrix_game[x[0]][7] = 1;
		else matrix_game[x[0]][y[0] - 1] = 1;

		for (i = 1; i < snake_len; i++)
			matrix_game[x[i - 1]][y[i - 1]] = matrix_game[x[i]][y[i]];

		matrix_game[x[snake_len - 1]][y[snake_len - 1]] = 0;

		for (i = snake_len - 1; i > 0; i--) {
			x[i] = x[i - 1];
			y[i] = y[i - 1];
		}

		if (!y[0]) y[0] = 7;
		else y[0] = y[0] - 1;

		if (x[0] == xaux && y[0] == yaux)
			return 1;
	}

	if (direction == 3) {
		if (y[0] == 7) matrix_game[x[0]][0] = 1;
		else matrix_game[x[0]][y[0]+ 1] = 1;
		
		for (i = 1; i < snake_len; i++)
			matrix_game[x[i - 1]][y[i - 1]] = matrix_game[x[i]][y[i]];

		matrix_game[x[snake_len - 1]][y[snake_len - 1]] = 0;

		for (i = snake_len - 1; i > 0; i--) {
			x[i] = x[i - 1];
			y[i] = y[i - 1];
		}

		if (y[0] == 7) y[0] = 0;
		else y[0] = y[0] + 1;

		if (x[0] == xaux && y[0] == yaux)
			return 1;
	}

	if ((x[0] == foodx) && (y[0] == foody)) {
		x[snake_len] = auxx;
		y[snake_len] = auxy;

		matrix_game[x[snake_len]][y[snake_len]] = 1;
		snake_len++;

		gen_food();
		matrix_game[foodx][foody] = 1;
	}

	/* sfarsit */
	for (i = 1; i < snake_len; i++)
		if (x[i] == x[0] && y[i] == y[0])
			return 1;

	/* retin ultima casuta */
	auxx = x[snake_len - 1];
	auxy = y[snake_len - 1];

	return 0;
	
}

void initialization()
{
	PORTB |= (1 << PB0);
	DDRB &= ~(1 << PB0); 
	PORTB |= (1 << PB1);
	DDRB &= ~(1 << PB1); 
	PORTB |= (1 << PB2);
	DDRB &= ~(1 << PB2);
	PORTB |= (1 << PB3);
	DDRB &= ~(1 << PB3);
	PORTB |= (1 << PB4);
	DDRB &= ~(1 << PB4);


}

int main()
{
	int i;
	
	DDRA = 0xFF; 
	DDRC = 0xFF; 
		
	PORTA = 0x00;
	PORTC = 0x00;
	
	for (i = 1; i < 8; i++)
		x[i] = 0, y[i] = 0;

	initialization();
	
	
	DDRA = 0xFF; 
	DDRC = 0xFF; 
		
	PORTA = 0x00;
	PORTC = 0x00;


	while(1) {
		 
		if (!(PINB & (1 << PB4))) break;
	}
	gen_food();
	matrix_game[foodx][foody] = 1;
	
	DDRA = 0xFF; 
	DDRC = 0xFF; 
		
	PORTA = 0x00;
	PORTC = 0x00;

	while (1) {
		int x1 = 0, x2 = 0;
		i = 0;

		/* pattern matrice initiala */
		while (x1 < 8 && x2 < 8) {
			matrix0[x1][x2] = 1;
			i = 0;

			while(i < 10) {
				draw_matrix(matrix0);
				++i;
			}

			if (!(x1 % 2)) ++x2;
			else --x2;
			
			if (x2 == 8) {
				x2 = 7;
				++x1;
			}
			if (x2 == - 1) {
				x2 = 0;
				++x1;
			}
		}


		while(1) {
			int i = 0;
			int curr_dir = direction;

			while(i < 100) {
				draw_matrix(matrix_game);
				i++;
				/* apasare buton */
				if (!(PINB & (1 << PB0)))
					if ((curr_dir == 2) || (curr_dir == 3))
						direction = 0;
				if (!(PINB & (1 << PB1)))
					if ((curr_dir == 0) || (curr_dir == 1))
						direction = 3;
				if (!(PINB & (1 << PB2)))
					if ((curr_dir == 0) || (curr_dir == 1))
						direction = 2;
				if (!(PINB & (1 << PB3)))
					if ((curr_dir == 2) || (curr_dir == 3))
						direction = 1;
			}

			int result = updatare_matrice();

			/* jocul s-a terminat */
			if (result == 1) {
				int it = 100;

				/* desenare "YOU LOSE" */
				while(1) {
					for (i = 0; i < it; i++)
						draw_matrix(matrixover1);
					for (i = 0; i < it; i++)
						draw_matrix(matrixover2);
					for (i = 0; i < it; i++)
						draw_matrix(matrixover3);
					for (i = 0; i < it; i++)
						draw_matrix(matrixover4);
					for (i = 0; i < it; i++)
						draw_matrix(matrixover2);
					for (i = 0; i < it; i++)
						draw_matrix(matrixover5);
					for (i = 0; i < it; i++)
						draw_matrix(matrixover6);
				}
			}
		}
	}

	return 0;
}
